#include			<stdio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<string.h>
#include			<time.h>

#include			"my_menu.h"
#include			"adeshdef.h"
#include			"adeshve.h"

#include			"desh_gen.h"
// #include			"deshgrph.h"
// #include			"deshfile.h"
#include			"desh_uc.h"

int menu_Set_Current_Cell_Type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Current_Cell_Type=VN_Menu_Entry-1;
	return(VN_MENU_EXIT);
 }


int menu_Define_User_Unit_Cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		int i,j;
		VN_Menu	User_Unit_Cell;
		char Unit_Cell_Entry[MAX_UNIT_CELL_ATOMS][40];

		if(Init_VN_Menu(&User_Unit_Cell, "Main / Unit Cell / User Defined", MAX_UNIT_CELL_ATOMS, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not Main/Unit Cell/User Defined menu");
					j=get_key_press();
					return(VN_MENU_EXIT);
				}
		Current_Cell_Type=VN_Menu_Entry-1;
//		Init_VN_Menu_Entry(&User_Unit_Cell, i+1, Unit_Cell_Entry[i],input_unit_cell_position);
		for(i=0; i<MAX_UNIT_CELL_ATOMS; i++)
			{
				format_unit_cell_entry(i, Unit_Cell_Entry[i]);
				Init_VN_Menu_Entry(&User_Unit_Cell, i+1, Unit_Cell_Entry[i],input_unit_cell_position);
			}
		Handle_VN_Menu(&User_Unit_Cell, 1);
		Close_VN_Menu(&User_Unit_Cell);

/* Now use only the valid positions */

		i=0;	j=0;
		for(i=0; i<MAX_UNIT_CELL_ATOMS; i++)
			{
				if((Unit_Cell_Atoms[USER_UC].U_Cell[i][0] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][0] >= 1. ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] >= 1. ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] >= 1. ))
						{
							Unit_Cell_Atoms[USER_UC].U_Cell[i][0] = -1.;
							Unit_Cell_Atoms[USER_UC].U_Cell[i][1] = -1.;
							Unit_Cell_Atoms[USER_UC].U_Cell[i][2] = -1.;
						}
				else
					{
						Unit_Cell_Atoms[USER_UC].U_Cell[j][0] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][0];
						Unit_Cell_Atoms[USER_UC].U_Cell[j][1] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][1];
						Unit_Cell_Atoms[USER_UC].U_Cell[j][2] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][2];
						if(i != j)
							{
								Unit_Cell_Atoms[USER_UC].U_Cell[i][0] = -1.;
								Unit_Cell_Atoms[USER_UC].U_Cell[i][1] = -1.;
								Unit_Cell_Atoms[USER_UC].U_Cell[i][2] = -1.;
							}
						j++;
					}
			}
		if(j == 0)
			{
				Unit_Cell_Atoms[USER_UC].U_Cell[0][0] = 0.;
				Unit_Cell_Atoms[USER_UC].U_Cell[0][1] = 0.;
				Unit_Cell_Atoms[USER_UC].U_Cell[0][2] = 0.;
				Unit_Cell_Atoms[USER_UC].No_of_U_Cell_Atoms=1;
			}
		else
			Unit_Cell_Atoms[USER_UC].No_of_U_Cell_Atoms=j;

		return(VN_MENU_EXIT);
	}


int input_unit_cell_position(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	int i, j;
	char temp[50];
	float a;

		j=VN_Menu_Entry-1;
		i=0;
		while(i<3)
		{
		 a=Unit_Cell_Atoms[USER_UC].U_Cell[j][i];
		 printf("Along %c : ", XYZ[i]);
		 a=get_float(a);
		 Unit_Cell_Atoms[USER_UC].U_Cell[j][i] = a;
		 i++;
		}
		format_unit_cell_entry(j, temp);
		Change_VN_Menu_Entry(VN_Menu_Name, VN_Menu_Entry, temp);
		return(VN_MENU_CONTINUE);
 }



void	format_unit_cell_entry(int i, char *c_string)
	{
		int j,k,l;
		char temp1[50];
		char temp[50];

		if((Unit_Cell_Atoms[USER_UC].U_Cell[i][0] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][0] >= 1. ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] >= 1. ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] >= 1. ))
				{
					sprintf(temp1, "Position %2d:      ,      ,       ",i+1);
				}
			else
				{
					sprintf(temp1, "Position %2d: ", i+1);
					for(l=0; l<3; l++)
						{
							decimal_to_fract(&j, &k,
								Unit_Cell_Atoms[USER_UC].U_Cell[i][l]);
							if(j == 0)
								sprintf(temp, " 0   ");
							else
								{
									if(k<10)
										sprintf(temp, "%1d/%1d  ", j,k);
									else
										sprintf(temp, "%1d/%2d ", j,k);
								}
							if(l != 2)
								strcat(temp, ", ");
							strcat(temp1, temp);
						}
				}
			strcpy(c_string, temp1);
	}

